/* This file is part of gPHPEdit, a GNOME2 PHP Editor.
 
   Copyright (C) 2003 Andy Jeffries
      andy@gphpedit.org
	  
   For more information or to find the latest release, visit our 
   website at http://www.gphpedit.org/
 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.
 
   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
 
   The GNU General Public License is contained in the file COPYING.*/


#include "preferences.h"
#include "main_window.h"
#include "main.h"

Preferences preferences;

void preferences_load(void)
{
	gint root_x;
	gint root_y;
	gint width;
	gint height;

	root_x = gnome_config_get_int ("gPHPEdit/main_window/x=20");
	root_y = gnome_config_get_int ("gPHPEdit/main_window/y=20");
	width = gnome_config_get_int ("gPHPEdit/main_window/width=400");
	height = gnome_config_get_int ("gPHPEdit/main_window/height=400");
	//g_print("X:%d\nY:%d\nW:%d\nH:%d\n", root_x, root_y, width, height);

	gtk_window_move(GTK_WINDOW(main_window.window), root_x, root_y);
	//gtk_window_resize(GTK_WINDOW(main_window.window), width, height);
	gtk_window_set_default_size(GTK_WINDOW(main_window.window), width, height);
	// foundry-family-weight-slant-

	preferences.default_font = gnome_config_get_string ("gPHPEdit/default_style/font=-*-courier-medium-r-*-*-12-*-*-*-*-*-*");
	preferences.default_fore = gnome_config_get_int ("gPHPEdit/default_style/fore=0");
	preferences.default_back = gnome_config_get_int ("gPHPEdit/default_style/back=16777215");

	preferences.line_number_font = gnome_config_get_string ("gPHPEdit/line_numbers/font=-*-courier-medium-r-*-*-12-*-*-*-*-*-*");
	preferences.line_number_fore = gnome_config_get_int ("gPHPEdit/line_numbers/fore=0");
	preferences.line_number_back = gnome_config_get_int ("gPHPEdit/line_numbers/back=11053224");

	preferences.set_sel_back = gnome_config_get_int ("gPHPEdit/default_style/selection=11250603");
	preferences.marker_back = gnome_config_get_int ("gPHPEdit/default_style/bookmark=15908608");
	preferences.php_binary_location = gnome_config_get_string ("gPHPEdit/locations/php_binary=php");
	preferences.shared_source_location = gnome_config_get_string ("gPHPEdit/locations/shared_source=/home/shares/websites/iaCodeBase/");
	preferences.indentation_size = gnome_config_get_int ("gPHPEdit/defaults/indentationsize=4");
	preferences.tab_size = gnome_config_get_int ("gPHPEdit/defaults/tabsize=4");
	preferences.auto_complete_delay = gnome_config_get_int ("gPHPEdit/defaults/auto_complete_delay=500");
	preferences.calltip_delay = gnome_config_get_int ("gPHPEdit/defaults/calltip_delay=500");
	preferences.show_indentation_guides = gnome_config_get_int ("gPHPEdit/defaults/showindentationguides=1");
	preferences.show_folding = gnome_config_get_int ("gPHPEdit/defaults/showfolding=1");
	preferences.edge_mode = gnome_config_get_int ("gPHPEdit/defaults/edgemode=0");
	preferences.edge_column = gnome_config_get_int ("gPHPEdit/defaults/edgecolumn=80");
	preferences.edge_colour = gnome_config_get_int ("gPHPEdit/defaults/edgecolour=8355712");
	preferences.line_wrapping = gnome_config_get_int ("gPHPEdit/defaults/linewrapping=1");
	//preferences.auto_indent_after_brace = gnome_config_get_int ("gPHPEdit/defaults/autoindentafterbrace=1");

	preferences.html_tag_back = gnome_config_get_int ("gPHPEdit/html_tag/back=16777215");
	preferences.html_tag_fore = gnome_config_get_int ("gPHPEdit/html_tag/fore=7553164");
	preferences.html_tag_font = gnome_config_get_string ("gPHPEdit/html_tag/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_tag_unknown_back = gnome_config_get_int ("gPHPEdit/html_tag_unknown/back=16777215");
	preferences.html_tag_unknown_fore = gnome_config_get_int ("gPHPEdit/html_tag_unknown/fore=7553164");
	preferences.html_tag_unknown_font = gnome_config_get_string ("gPHPEdit/html_tag_unknown/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_attribute_back = gnome_config_get_int ("gPHPEdit/html_attribute/back=16777215");
	preferences.html_attribute_fore = gnome_config_get_int ("gPHPEdit/html_attribute/fore=9204544");
	preferences.html_attribute_font = gnome_config_get_string ("gPHPEdit/html_attribute/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_attribute_unknown_back = gnome_config_get_int ("gPHPEdit/html_attribute_unknown/back=16777215");
	preferences.html_attribute_unknown_fore = gnome_config_get_int ("gPHPEdit/html_attribute_unknown/fore=7472544");
	preferences.html_attribute_unknown_font = gnome_config_get_string ("gPHPEdit/html_attribute_unknown/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_number_back = gnome_config_get_int ("gPHPEdit/html_number/back=16777215");
	preferences.html_number_fore = gnome_config_get_int ("gPHPEdit/html_number/fore=9204544");
	preferences.html_number_font = gnome_config_get_string ("gPHPEdit/html_number/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_single_string_back = gnome_config_get_int ("gPHPEdit/html_single_string/back=16777215");
	preferences.html_single_string_fore = gnome_config_get_int ("gPHPEdit/html_single_string/fore=32768");
	preferences.html_single_string_font = gnome_config_get_string ("gPHPEdit/html_single_string/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_double_string_back = gnome_config_get_int ("gPHPEdit/html_double_string/back=16777215");
	preferences.html_double_string_fore = gnome_config_get_int ("gPHPEdit/html_double_string/fore=32768");
	preferences.html_double_string_font = gnome_config_get_string ("gPHPEdit/html_double_string/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_comment_back = gnome_config_get_int ("gPHPEdit/html_comment/back=16777215");
	preferences.html_comment_fore = gnome_config_get_int ("gPHPEdit/html_comment/fore=8421504");
	preferences.html_comment_font = gnome_config_get_string ("gPHPEdit/html_comment/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_entity_back = gnome_config_get_int ("gPHPEdit/html_entity/back=16777215");
	preferences.html_entity_fore = gnome_config_get_int ("gPHPEdit/html_entity/fore=8421504");
	preferences.html_entity_font = gnome_config_get_string ("gPHPEdit/html_entity/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_script_back = gnome_config_get_int ("gPHPEdit/html_script/back=16777215");
	preferences.html_script_fore = gnome_config_get_int ("gPHPEdit/html_script/fore=7553165");
	preferences.html_script_font = gnome_config_get_string ("gPHPEdit/html_script/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_question_back = gnome_config_get_int ("gPHPEdit/html_question/back=16777215");
	preferences.html_question_fore = gnome_config_get_int ("gPHPEdit/html_question/fore=7553165");
	preferences.html_question_font = gnome_config_get_string ("gPHPEdit/html_question/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.html_value_back = gnome_config_get_int ("gPHPEdit/html_value/back=16777215");
	preferences.html_value_fore = gnome_config_get_int ("gPHPEdit/html_value/fore=21632");
	preferences.html_value_font = gnome_config_get_string ("gPHPEdit/html_value/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.javascript_comment_back = gnome_config_get_int ("gPHPEdit/javascript_comment/back=16777215");
	preferences.javascript_comment_fore = gnome_config_get_int ("gPHPEdit/javascript_comment/fore=8421504");
	preferences.javascript_comment_font = gnome_config_get_string ("gPHPEdit/javascript_comment/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.javascript_comment_line_back = gnome_config_get_int ("gPHPEdit/javascript_comment_line/back=16777215");
	preferences.javascript_comment_line_fore = gnome_config_get_int ("gPHPEdit/javascript_comment_line/fore=8421504");
	preferences.javascript_comment_line_font = gnome_config_get_string ("gPHPEdit/javascript_comment_line/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.javascript_comment_doc_back = gnome_config_get_int ("gPHPEdit/javascript_comment_doc/back=16777215");
	preferences.javascript_comment_doc_fore = gnome_config_get_int ("gPHPEdit/javascript_comment_doc/fore=8355712");
	preferences.javascript_comment_doc_font = gnome_config_get_string ("gPHPEdit/javascript_comment_doc/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.javascript_word_back = gnome_config_get_int ("gPHPEdit/javascript_word/back=16777215");
	preferences.javascript_word_fore = gnome_config_get_int ("gPHPEdit/javascript_word/fore=9204544");
	preferences.javascript_word_font = gnome_config_get_string ("gPHPEdit/javascript_word/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.javascript_keyword_back = gnome_config_get_int ("gPHPEdit/javascript_keyword/back=16777215");
	preferences.javascript_keyword_fore = gnome_config_get_int ("gPHPEdit/javascript_keyword/fore=8388608");
	preferences.javascript_keyword_font = gnome_config_get_string ("gPHPEdit/javascript_keyword/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*-*");

	preferences.javascript_doublestring_back = gnome_config_get_int ("gPHPEdit/javascript_doublestring/back=16777215");
	preferences.javascript_doublestring_fore = gnome_config_get_int ("gPHPEdit/javascript_doublestring/fore=8388608");
	preferences.javascript_doublestring_font = gnome_config_get_string ("gPHPEdit/javascript_doublestring/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.javascript_singlestring_back = gnome_config_get_int ("gPHPEdit/javascript_singlestring/back=16777215");
	preferences.javascript_singlestring_fore = gnome_config_get_int ("gPHPEdit/javascript_singlestring/fore=8388608");
	preferences.javascript_singlestring_font = gnome_config_get_string ("gPHPEdit/javascript_singlestring/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");

	preferences.javascript_symbols_back = gnome_config_get_int ("gPHPEdit/javascript_symbols/back=16777215");
	preferences.javascript_symbols_fore = gnome_config_get_int ("gPHPEdit/javascript_symbols/fore=8355712");
	preferences.javascript_symbols_font = gnome_config_get_string ("gPHPEdit/javascript_symbols/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*-*");

	preferences.php_default_font = gnome_config_get_string ("gPHPEdit/php_default_style/font=-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.php_default_fore = gnome_config_get_int ("gPHPEdit/php_default_style/fore=1052688");
	preferences.php_default_back = gnome_config_get_int ("gPHPEdit/php_default_style/back=14935295");

	preferences.php_hstring_fore = gnome_config_get_int ("gPHPEdit/php_hstring/fore=8388736");
	preferences.php_hstring_font = gnome_config_get_string ("gPHPEdit/php_hstring/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.php_hstring_back = gnome_config_get_int ("gPHPEdit/php_hstring/back=16777215");

	preferences.php_simplestring_fore = gnome_config_get_int ("gPHPEdit/php_simplestring/fore=8388736");
	preferences.php_simplestring_font = gnome_config_get_string ("gPHPEdit/php_simplestring/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.php_simplestring_back = gnome_config_get_int ("gPHPEdit/php_simplestring/back=16777215");

	preferences.php_word_fore = gnome_config_get_int ("gPHPEdit/php_word/fore=0");
	preferences.php_word_font = gnome_config_get_string ("gPHPEdit/php_word/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*");
	preferences.php_word_back = gnome_config_get_int ("gPHPEdit/php_word/back=16777215");

	preferences.php_number_fore = gnome_config_get_int ("gPHPEdit/php_number/fore=9204544");
	preferences.php_number_font = gnome_config_get_string ("gPHPEdit/php_number/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.php_number_back = gnome_config_get_int ("gPHPEdit/php_number/back=16777215");

	preferences.php_variable_fore = gnome_config_get_int ("gPHPEdit/php_variable/fore=16746496");
	preferences.php_variable_font = gnome_config_get_string ("gPHPEdit/php_variable/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.php_variable_back = gnome_config_get_int ("gPHPEdit/php_variable/back=16777215");

	preferences.php_comment_fore = gnome_config_get_int ("gPHPEdit/php_comment/fore=8421504");
	preferences.php_comment_font = gnome_config_get_string ("gPHPEdit/php_comment/font=-*-*-*-o-*-*-*-*-*-*-*-*-*-*");
	preferences.php_comment_back = gnome_config_get_int ("gPHPEdit/php_comment/back=16777215");

	preferences.php_comment_line_fore = gnome_config_get_int ("gPHPEdit/php_comment_line/fore=8421504");
	preferences.php_comment_line_font = gnome_config_get_string ("gPHPEdit/php_comment_line/font=-*-*-*-o-*-*-*-*-*-*-*-*-*-*");
	preferences.php_comment_line_back = gnome_config_get_int ("gPHPEdit/php_comment_line/back=16777215");

	preferences.css_tag_back = gnome_config_get_int ("gPHPEdit/css_tag/back=16777215");
	preferences.css_tag_font = gnome_config_get_string ("gPHPEdit/css_tag/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_tag_fore = gnome_config_get_int ("gPHPEdit/css_tag/fore=8388608");
	preferences.css_class_fore = gnome_config_get_int ("gPHPEdit/css_class/fore=8388608");
	preferences.css_class_font = gnome_config_get_string ("gPHPEdit/css_class/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_class_back = gnome_config_get_int ("gPHPEdit/css_class/back=16777215");
	preferences.css_pseudoclass_back = gnome_config_get_int ("gPHPEdit/css_pseudoclass/back=16777215");
	preferences.css_pseudoclass_font = gnome_config_get_string ("gPHPEdit/css_pseudoclass/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_pseudoclass_fore = gnome_config_get_int ("gPHPEdit/css_pseudoclass/fore=8388608");
	preferences.css_unknown_pseudoclass_fore = gnome_config_get_int ("gPHPEdit/css_unknown_pseudoclass/fore=16711680");
	preferences.css_unknown_pseudoclass_font = gnome_config_get_string ("gPHPEdit/css_unknown_pseudoclass/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_unknown_pseudoclass_back = gnome_config_get_int ("gPHPEdit/css_unknown_pseudoclass/back=16777215");
	preferences.css_operator_fore = gnome_config_get_int ("gPHPEdit/css_operator/fore=128");
	preferences.css_operator_font = gnome_config_get_string ("gPHPEdit/css_operator/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_operator_back = gnome_config_get_int ("gPHPEdit/css_operator/back=16777215");
	preferences.css_identifier_fore = gnome_config_get_int ("gPHPEdit/css_identifier/fore=0");
	preferences.css_identifier_font = gnome_config_get_string ("gPHPEdit/css_identifier/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_identifier_back = gnome_config_get_int ("gPHPEdit/css_identifier/back=16777215");
	preferences.css_unknown_identifier_fore = gnome_config_get_int ("gPHPEdit/css_unknown_identifier/fore=16711680");
	preferences.css_unknown_identifier_font = gnome_config_get_string ("gPHPEdit/css_unknown_identifier/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_unknown_identifier_back = gnome_config_get_int ("gPHPEdit/css_unknown_identifier/back=16777215");
	preferences.css_value_fore = gnome_config_get_int ("gPHPEdit/css_value/fore=8388736");
	preferences.css_value_font = gnome_config_get_string ("gPHPEdit/css_value/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_value_back = gnome_config_get_int ("gPHPEdit/css_value/back=16777215");
	preferences.css_comment_fore = gnome_config_get_int ("gPHPEdit/css_comment/fore=8421504");
	preferences.css_comment_font = gnome_config_get_string ("gPHPEdit/css_comment/font=-*-*-*-o-*-*-*-*-*-*-*-*-*-*");
	preferences.css_comment_back = gnome_config_get_int ("gPHPEdit/css_comment/back=16777215");
	preferences.css_id_font = gnome_config_get_string ("gPHPEdit/css_id/fore=8388608");
	preferences.css_id_fore = gnome_config_get_int ("gPHPEdit/css_id/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_id_back = gnome_config_get_int ("gPHPEdit/css_id/back=16777215");
	preferences.css_important_font = gnome_config_get_string ("gPHPEdit/css_important/fore=255");
	preferences.css_important_fore = gnome_config_get_int ("gPHPEdit/css_important/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_important_back = gnome_config_get_int ("gPHPEdit/css_important/back=16777215");
	preferences.css_directive_fore = gnome_config_get_int ("gPHPEdit/css_directive/fore=32768");
	preferences.css_directive_font = gnome_config_get_string ("gPHPEdit/css_directive/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*-*");
	preferences.css_directive_back = gnome_config_get_int ("gPHPEdit/css_directive/back=16777215");
	
	preferences.sql_word_fore = gnome_config_get_int ("gPHPEdit/sql_word/fore=0");
	preferences.sql_word_font = gnome_config_get_string ("gPHPEdit/sql_word/font=-*-*-bold-*-*-*-*-*-*-*-*-*-*");
	preferences.sql_word_back = gnome_config_get_int ("gPHPEdit/sql_word/back=16777215");
	preferences.sql_string_fore = gnome_config_get_int ("gPHPEdit/sql_string/fore=8388736");
	preferences.sql_string_font = gnome_config_get_string ("gPHPEdit/sql_string/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.sql_string_back = gnome_config_get_int ("gPHPEdit/sql_string/back=16777215");
	preferences.sql_operator_fore = gnome_config_get_int ("gPHPEdit/sql_operator/fore=0");
	preferences.sql_operator_font = gnome_config_get_string ("gPHPEdit/sql_operator/font=-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.sql_operator_back = gnome_config_get_int ("gPHPEdit/sql_operator/back=16777215");
	preferences.sql_comment_fore = gnome_config_get_int ("gPHPEdit/sql_comment/fore=8421504");
	preferences.sql_comment_font = gnome_config_get_string ("gPHPEdit/sql_comment/font=-*-*-*-o-*-*-*-*-*-*-*-*-*-*");
	preferences.sql_comment_back = gnome_config_get_int ("gPHPEdit/sql_comment/back=16777215");
	preferences.sql_number_fore = gnome_config_get_int ("gPHPEdit/sql_number/fore=9204544");
	preferences.sql_number_font = gnome_config_get_string ("gPHPEdit/sql_number/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.sql_number_back = gnome_config_get_int ("gPHPEdit/sql_number/back=16777215");
	preferences.sql_identifier_fore = gnome_config_get_int ("gPHPEdit/sql_identifier/fore=16746496");
	preferences.sql_identifier_font = gnome_config_get_string ("gPHPEdit/sql_identifier/font=-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	preferences.sql_identifier_back = gnome_config_get_int ("gPHPEdit/sql_identifier/back=16777215");
}


void move_classbrowser_position(void)
{
	gtk_paned_set_position(GTK_PANED(main_window.main_horizontal_pane),gnome_config_get_int ("gPHPEdit/main_window/classbrowser_size=100"));
}

void save_classbrowser_position(void)
{
	if (gtk_paned_get_position(GTK_PANED(main_window.main_horizontal_pane)) != 0) {
		gnome_config_set_int("gPHPEdit/main_window/classbrowser_size", gtk_paned_get_position(GTK_PANED(main_window.main_horizontal_pane)));
		gnome_config_sync();
	}
}

void main_window_size_save_details(gint x, gint y, gint width, gint height)
{
	gnome_config_set_int ("gPHPEdit/main_window/x", x);
	gnome_config_set_int ("gPHPEdit/main_window/y", y);
	gnome_config_set_int ("gPHPEdit/main_window/width", width);
	gnome_config_set_int ("gPHPEdit/main_window/height", height);
	//g_print("X:%d\nY:%d\nW:%d\nH:%d\n", x, y, width, height);
}


void main_window_size_save(void)
{
	gint root_x;
	gint root_y;
	gint width;
	gint height;

	gtk_window_get_position(GTK_WINDOW(main_window.window), &root_x, &root_y);
	gtk_window_get_size(GTK_WINDOW(main_window.window), &width, &height);
	main_window_size_save_details(root_x, root_y, width, height);
	gnome_config_set_int("gPHPEdit/main_window/classbrowser_size", gtk_paned_get_position(GTK_PANED(main_window.main_horizontal_pane)));
}


void preferences_save(void)
{
	//main_window_size_save();

	gnome_config_set_string ("gPHPEdit/default_style/font", preferences.default_font);
	gnome_config_set_int ("gPHPEdit/default_style/fore", preferences.default_fore);
	gnome_config_set_int ("gPHPEdit/default_style/back", preferences.default_back);

	gnome_config_set_string ("gPHPEdit/line_numbers/font", preferences.line_number_font);
	gnome_config_set_int ("gPHPEdit/line_numbers/fore", preferences.line_number_fore);
	gnome_config_set_int ("gPHPEdit/line_numbers/back", preferences.line_number_back);

	gnome_config_set_int ("gPHPEdit/default_style/selection", preferences.set_sel_back);
	gnome_config_set_int ("gPHPEdit/default_style/bookmark", preferences.marker_back);
	gnome_config_set_string ("gPHPEdit/locations/php_binary", preferences.php_binary_location);
	gnome_config_set_string ("gPHPEdit/locations/shared_source", preferences.shared_source_location);

	gnome_config_set_int ("gPHPEdit/defaults/indentationsize", preferences.indentation_size);
	gnome_config_set_int ("gPHPEdit/defaults/tabsize", preferences.tab_size);
	gnome_config_set_int ("gPHPEdit/defaults/linewrapping", preferences.line_wrapping);

	gnome_config_set_int ("gPHPEdit/defaults/showindentationguides", preferences.show_indentation_guides);
	gnome_config_set_int ("gPHPEdit/defaults/showfolding", preferences.show_folding);
	gnome_config_set_int ("gPHPEdit/defaults/edgemode", preferences.edge_mode);
	gnome_config_set_int ("gPHPEdit/defaults/edgecolumn", preferences.edge_column);
	gnome_config_set_int ("gPHPEdit/defaults/edgecolour", preferences.edge_colour);
	gnome_config_set_int ("gPHPEdit/defaults/auto_complete_delay", preferences.auto_complete_delay);
	gnome_config_set_int ("gPHPEdit/defaults/calltip_delay", preferences.calltip_delay);
	//gnome_config_set_int ("gPHPEdit/defaults/autoindentafterbrace", preferences.auto_indent_after_brace);


	gnome_config_set_int ("gPHPEdit/html_tag/back", preferences.html_tag_back);
	gnome_config_set_int ("gPHPEdit/html_tag/fore", preferences.html_tag_fore);
	gnome_config_set_string ("gPHPEdit/html_tag/font", preferences.html_tag_font);

	gnome_config_set_int ("gPHPEdit/html_tag_unknown/back", preferences.html_tag_unknown_back);
	gnome_config_set_int ("gPHPEdit/html_tag_unknown/fore", preferences.html_tag_unknown_fore);
	gnome_config_set_string ("gPHPEdit/html_tag_unknown/font", preferences.html_tag_unknown_font);

	gnome_config_set_int ("gPHPEdit/html_attribute/back", preferences.html_attribute_back);
	gnome_config_set_int ("gPHPEdit/html_attribute/fore", preferences.html_attribute_fore);
	gnome_config_set_string ("gPHPEdit/html_attribute/font", preferences.html_attribute_font);

	gnome_config_set_int ("gPHPEdit/html_attribute_unknown/back", preferences.html_attribute_unknown_back);
	gnome_config_set_int ("gPHPEdit/html_attribute_unknown/fore", preferences.html_attribute_unknown_fore);
	gnome_config_set_string ("gPHPEdit/html_attribute_unknown/font", preferences.html_attribute_unknown_font);

	gnome_config_set_int ("gPHPEdit/html_number/back", preferences.html_number_back);
	gnome_config_set_int ("gPHPEdit/html_number/fore", preferences.html_number_fore);
	gnome_config_set_string ("gPHPEdit/html_number/font", preferences.html_number_font);

	gnome_config_set_int ("gPHPEdit/html_single_string/back", preferences.html_single_string_back);
	gnome_config_set_int ("gPHPEdit/html_single_string/fore", preferences.html_single_string_fore);
	gnome_config_set_string ("gPHPEdit/html_single_string/font", preferences.html_single_string_font);

	gnome_config_set_int ("gPHPEdit/html_double_string/back", preferences.html_double_string_back);
	gnome_config_set_int ("gPHPEdit/html_double_string/fore", preferences.html_double_string_fore);
	gnome_config_set_string ("gPHPEdit/html_double_string/font", preferences.html_double_string_font);

	gnome_config_set_int ("gPHPEdit/html_comment/back", preferences.html_comment_back);
	gnome_config_set_int ("gPHPEdit/html_comment/fore", preferences.html_comment_fore);
	gnome_config_set_string ("gPHPEdit/html_comment/font", preferences.html_comment_font);

	gnome_config_set_int ("gPHPEdit/html_entity/back", preferences.html_entity_back);
	gnome_config_set_int ("gPHPEdit/html_entity/fore", preferences.html_entity_fore);
	gnome_config_set_string ("gPHPEdit/html_entity/font", preferences.html_entity_font);

	gnome_config_set_int ("gPHPEdit/html_script/back", preferences.html_script_back);
	gnome_config_set_int ("gPHPEdit/html_script/fore", preferences.html_script_fore);
	gnome_config_set_string ("gPHPEdit/html_script/font", preferences.html_script_font);

	gnome_config_set_int ("gPHPEdit/html_question/back", preferences.html_question_back);
	gnome_config_set_int ("gPHPEdit/html_question/fore", preferences.html_question_fore);
	gnome_config_set_string ("gPHPEdit/html_question/font", preferences.html_question_font);

	gnome_config_set_int ("gPHPEdit/html_value/back", preferences.html_value_back);
	gnome_config_set_int ("gPHPEdit/html_value/fore", preferences.html_value_fore);
	gnome_config_set_string ("gPHPEdit/html_value/font", preferences.html_value_font);

	gnome_config_set_int ("gPHPEdit/javascript_comment/back", preferences.javascript_comment_back);
	gnome_config_set_int ("gPHPEdit/javascript_comment/fore", preferences.javascript_comment_fore);
	gnome_config_set_string ("gPHPEdit/javascript_comment/font", preferences.javascript_comment_font);

	gnome_config_set_int ("gPHPEdit/javascript_comment_line/back", preferences.javascript_comment_line_back);
	gnome_config_set_int ("gPHPEdit/javascript_comment_line/fore", preferences.javascript_comment_line_fore);
	gnome_config_set_string ("gPHPEdit/javascript_comment_line/font", preferences.javascript_comment_line_font);

	gnome_config_set_int ("gPHPEdit/javascript_comment_doc/back", preferences.javascript_comment_doc_back);
	gnome_config_set_int ("gPHPEdit/javascript_comment_doc/fore", preferences.javascript_comment_doc_fore);
	gnome_config_set_string ("gPHPEdit/javascript_comment_doc/font", preferences.javascript_comment_doc_font);

	gnome_config_set_int ("gPHPEdit/javascript_word/back", preferences.javascript_word_back);
	gnome_config_set_int ("gPHPEdit/javascript_word/fore", preferences.javascript_word_fore);
	gnome_config_set_string ("gPHPEdit/javascript_word/font", preferences.javascript_word_font);

	gnome_config_set_int ("gPHPEdit/javascript_keyword/back", preferences.javascript_keyword_back);
	gnome_config_set_int ("gPHPEdit/javascript_keyword/fore", preferences.javascript_keyword_fore);
	gnome_config_set_string ("gPHPEdit/javascript_keyword/font", preferences.javascript_keyword_font);

	gnome_config_set_int ("gPHPEdit/javascript_doublestring/back", preferences.javascript_doublestring_back);
	gnome_config_set_int ("gPHPEdit/javascript_doublestring/fore", preferences.javascript_doublestring_fore);
	gnome_config_set_string ("gPHPEdit/javascript_doublestring/font", preferences.javascript_doublestring_font);

	gnome_config_set_int ("gPHPEdit/javascript_singlestring/back", preferences.javascript_singlestring_back);
	gnome_config_set_int ("gPHPEdit/javascript_singlestring/fore", preferences.javascript_singlestring_fore);
	gnome_config_set_string ("gPHPEdit/javascript_singlestring/font", preferences.javascript_singlestring_font);

	gnome_config_set_int ("gPHPEdit/javascript_symbols/back", preferences.javascript_symbols_back);
	gnome_config_set_int ("gPHPEdit/javascript_symbols/fore", preferences.javascript_symbols_fore);
	gnome_config_set_string ("gPHPEdit/javascript_symbols/font", preferences.javascript_symbols_font);

	gnome_config_set_int ("gPHPEdit/php_default/back", preferences.php_default_back);
	gnome_config_set_int ("gPHPEdit/php_default/fore", preferences.php_default_fore);
	gnome_config_set_string ("gPHPEdit/php_default/font", preferences.php_default_font);

	gnome_config_set_int ("gPHPEdit/php_hstring/fore", preferences.php_hstring_fore);
	gnome_config_set_string ("gPHPEdit/php_hstring/font", preferences.php_hstring_font);
	gnome_config_set_int ("gPHPEdit/php_hstring/back", preferences.php_hstring_back);

	gnome_config_set_int ("gPHPEdit/php_simplestring/fore", preferences.php_simplestring_fore);
	gnome_config_set_string ("gPHPEdit/php_simplestring/font", preferences.php_simplestring_font);
	gnome_config_set_int ("gPHPEdit/php_simplestring/back", preferences.php_simplestring_back);

	gnome_config_set_int ("gPHPEdit/php_word/fore", preferences.php_word_fore);
	gnome_config_set_string ("gPHPEdit/php_word/font", preferences.php_word_font);
	gnome_config_set_int ("gPHPEdit/php_word/back", preferences.php_word_back);

	gnome_config_set_int ("gPHPEdit/php_number/fore", preferences.php_number_fore);
	gnome_config_set_string ("gPHPEdit/php_number/font", preferences.php_number_font);
	gnome_config_set_int ("gPHPEdit/php_number/back", preferences.php_number_back);

	gnome_config_set_int ("gPHPEdit/php_variable/fore", preferences.php_variable_fore);
	gnome_config_set_string ("gPHPEdit/php_variable/font", preferences.php_variable_font);
	gnome_config_set_int ("gPHPEdit/php_variable/back", preferences.php_variable_back);

	gnome_config_set_int ("gPHPEdit/php_comment/fore", preferences.php_comment_fore);
	gnome_config_set_string ("gPHPEdit/php_comment/font", preferences.php_comment_font);
	gnome_config_set_int ("gPHPEdit/php_comment/back", preferences.php_comment_back);

	gnome_config_set_int ("gPHPEdit/php_comment_line/fore", preferences.php_comment_line_fore);
	gnome_config_set_string ("gPHPEdit/php_comment_line/font", preferences.php_comment_line_font);
	gnome_config_set_int ("gPHPEdit/php_comment/back", preferences.php_comment_back);

	gnome_config_set_int ("gPHPEdit/css_tag/back", preferences.css_tag_back);
	gnome_config_set_string ("gPHPEdit/css_tag/font", preferences.css_tag_font);
	gnome_config_set_int ("gPHPEdit/css_tag/fore", preferences.css_tag_fore);
	gnome_config_set_int ("gPHPEdit/css_class/fore", preferences.css_class_fore);
	gnome_config_set_string ("gPHPEdit/css_class/font", preferences.css_class_font);
	gnome_config_set_int ("gPHPEdit/css_class/back", preferences.css_class_back);
	gnome_config_set_int ("gPHPEdit/css_pseudoclass/back", preferences.css_pseudoclass_back);
	gnome_config_set_string ("gPHPEdit/css_pseudoclass/font", preferences.css_pseudoclass_font);
	gnome_config_set_int ("gPHPEdit/css_pseudoclass/fore", preferences.css_pseudoclass_fore);
	gnome_config_set_int ("gPHPEdit/css_unknown_pseudoclass/fore", preferences.css_unknown_pseudoclass_fore);
	gnome_config_set_string ("gPHPEdit/css_unknown_pseudoclass/font", preferences.css_unknown_pseudoclass_font);
	gnome_config_set_int ("gPHPEdit/css_unknown_pseudoclass/back", preferences.css_unknown_pseudoclass_back);
	gnome_config_set_int ("gPHPEdit/css_operator/fore", preferences.css_operator_fore);
	gnome_config_set_string ("gPHPEdit/css_operator/font", preferences.css_operator_font);
	gnome_config_set_int ("gPHPEdit/css_operator/back", preferences.css_operator_back);
	gnome_config_set_int ("gPHPEdit/css_identifier/fore", preferences.css_identifier_fore);
	gnome_config_set_string ("gPHPEdit/css_identifier/font", preferences.css_identifier_font);
	gnome_config_set_int ("gPHPEdit/css_identifier/back", preferences.css_identifier_back);
	gnome_config_set_int ("gPHPEdit/css_unknown_identifier/fore", preferences.css_unknown_identifier_fore);
	gnome_config_set_string ("gPHPEdit/css_unknown_identifier/font", preferences.css_unknown_identifier_font);
	gnome_config_set_int ("gPHPEdit/css_unknown_identifier/back=16777215", preferences.css_unknown_identifier_back);
	gnome_config_set_int ("gPHPEdit/css_value/fore", preferences.css_value_fore);
	gnome_config_set_string ("gPHPEdit/css_value/font", preferences.css_value_font);
	gnome_config_set_int ("gPHPEdit/css_value/back", preferences.css_value_back);
	gnome_config_set_int ("gPHPEdit/css_comment/fore", preferences.css_comment_fore);
	gnome_config_set_string ("gPHPEdit/css_comment/font", preferences.css_comment_font);
	gnome_config_set_int ("gPHPEdit/css_comment/back", preferences.css_comment_back);
	gnome_config_set_string ("gPHPEdit/css_id/fore", preferences.css_id_font);
	gnome_config_set_int ("gPHPEdit/css_id/font", preferences.css_id_fore);
	gnome_config_set_int ("gPHPEdit/css_id/back", preferences.css_id_back);
	gnome_config_set_string ("gPHPEdit/css_important/fore", preferences.css_important_font);
	gnome_config_set_int ("gPHPEdit/css_important/font", preferences.css_important_fore);
	gnome_config_set_int ("gPHPEdit/css_important/back", preferences.css_important_back);
	gnome_config_set_int ("gPHPEdit/css_directive/fore", preferences.css_directive_fore);
	gnome_config_set_string ("gPHPEdit/css_directive/font", preferences.css_directive_font);
	gnome_config_set_int ("gPHPEdit/css_directive/back", preferences.css_directive_back);

	gnome_config_set_int ("gPHPEdit/sql_word/fore", preferences.sql_word_fore);
	gnome_config_set_string ("gPHPEdit/sql_word/font", preferences.sql_word_font);
	gnome_config_set_int ("gPHPEdit/sql_word/back", preferences.sql_word_back);
	gnome_config_set_int ("gPHPEdit/sql_string/fore", preferences.sql_string_fore);
	gnome_config_set_string ("gPHPEdit/sql_string/font", preferences.sql_string_font);
	gnome_config_set_int ("gPHPEdit/sql_string/back", preferences.sql_string_back);
	gnome_config_set_int ("gPHPEdit/sql_operator/fore", preferences.sql_operator_fore);
	gnome_config_set_string ("gPHPEdit/sql_operator/font", preferences.sql_operator_font);
	gnome_config_set_int ("gPHPEdit/sql_operator/back", preferences.sql_operator_back);
	gnome_config_set_int ("gPHPEdit/sql_comment/fore", preferences.sql_comment_fore);
	gnome_config_set_string ("gPHPEdit/sql_comment/font", preferences.sql_comment_font);
	gnome_config_set_int ("gPHPEdit/sql_comment/back", preferences.sql_comment_back);
	gnome_config_set_int ("gPHPEdit/sql_number/fore", preferences.sql_number_fore);
	gnome_config_set_string ("gPHPEdit/sql_number/font", preferences.sql_number_font);
	gnome_config_set_int ("gPHPEdit/sql_number/back", preferences.sql_number_back);
	gnome_config_set_int ("gPHPEdit/sql_identifier/fore", preferences.sql_identifier_fore);
	gnome_config_set_string ("gPHPEdit/sql_identifier/font", preferences.sql_identifier_font);
	gnome_config_set_int ("gPHPEdit/sql_identifier/back", preferences.sql_identifier_back);

	gnome_config_sync();
}
