/* This file is part of gPHPEdit, a GNOME2 PHP Editor.
 
   Copyright (C) 2003 Andy Jeffries
      andy@gphpedit.org
	  
   For more information or to find the latest release, visit our 
   website at http://www.gphpedit.org/
 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.
 
   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
 
   The GNU General Public License is contained in the file COPYING.*/


#include "preferences_dialog.h"

PreferencesDialog preferences_dialog;

void get_current_preferences(void)
{
	//fill_in_highlighting_list();

}

void set_current_preferences(void)
{
	//set_from_highlighting_list();
}


void ok_clicked(GtkButton *button, gpointer data)
{
	set_current_preferences();
	g_print("OK\n");
	gtk_widget_destroy(preferences_dialog.window);
}


void preferences_window_destroyed(GtkWidget *widget, gpointer data)
{
	gtk_grab_remove(preferences_dialog.window);
	preferences_dialog.window = NULL;
}

void preferences_dialog_create (void)
{
	preferences_dialog.window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (preferences_dialog.window), "Preferences");
	gtk_window_set_modal (GTK_WINDOW (preferences_dialog.window), TRUE);
	gtk_window_set_resizable (GTK_WINDOW (preferences_dialog.window), FALSE);
	gtk_window_set_destroy_with_parent (GTK_WINDOW (preferences_dialog.window), TRUE);

	preferences_dialog.vbox1 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (preferences_dialog.vbox1);
	gtk_container_add (GTK_CONTAINER (preferences_dialog.window), preferences_dialog.vbox1);

	preferences_dialog.notebook1 = gtk_notebook_new ();
	gtk_widget_show (preferences_dialog.notebook1);
	gtk_box_pack_start (GTK_BOX (preferences_dialog.vbox1), preferences_dialog.notebook1, TRUE, TRUE, 0);

	preferences_dialog.fixed1 = gtk_fixed_new ();
	gtk_widget_show (preferences_dialog.fixed1);
	gtk_container_add (GTK_CONTAINER (preferences_dialog.notebook1), preferences_dialog.fixed1);

	preferences_dialog.colorpicker1 = gnome_color_picker_new ();
	gtk_widget_show (preferences_dialog.colorpicker1);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed1), preferences_dialog.colorpicker1, 160, 96);
	gtk_widget_set_size_request (preferences_dialog.colorpicker1, 36, 28);

	preferences_dialog.hscale2 = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (72, 0, 120, 1, 0, 0)));
	gtk_widget_show (preferences_dialog.hscale2);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed1), preferences_dialog.hscale2, 120, 136);
	gtk_widget_set_size_request (preferences_dialog.hscale2, 208, 40);
	gtk_scale_set_digits (GTK_SCALE (preferences_dialog.hscale2), 0);

	preferences_dialog.hscale1 = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (4, 0, 16, 1, 0, 0)));
	gtk_widget_show (preferences_dialog.hscale1);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed1), preferences_dialog.hscale1, 120, 8);
	gtk_widget_set_size_request (preferences_dialog.hscale1, 208, 32);
	gtk_scale_set_digits (GTK_SCALE (preferences_dialog.hscale1), 0);

	preferences_dialog.label4 = gtk_label_new ("Tab size");
	gtk_widget_show (preferences_dialog.label4);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed1), preferences_dialog.label4, 8, 24);
	gtk_widget_set_size_request (preferences_dialog.label4, 48, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label4), GTK_JUSTIFY_LEFT);

	preferences_dialog.checkbutton1 = gtk_check_button_new_with_mnemonic ("Show indentation guides");
	gtk_widget_show (preferences_dialog.checkbutton1);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed1), preferences_dialog.checkbutton1, 8, 64);
	gtk_widget_set_size_request (preferences_dialog.checkbutton1, 184, 16);

	preferences_dialog.label6 = gtk_label_new ("Edge Column");
	gtk_widget_show (preferences_dialog.label6);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed1), preferences_dialog.label6, 8, 155);
	gtk_widget_set_size_request (preferences_dialog.label6, 80, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label6), GTK_JUSTIFY_LEFT);

	preferences_dialog.label5 = gtk_label_new ("Right-hand edge colour");
	gtk_widget_show (preferences_dialog.label5);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed1), preferences_dialog.label5, 8, 102);
	gtk_widget_set_size_request (preferences_dialog.label5, 136, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label5), GTK_JUSTIFY_LEFT);

	preferences_dialog.label1 = gtk_label_new ("General");
	gtk_widget_show (preferences_dialog.label1);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (preferences_dialog.notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (preferences_dialog.notebook1), 0), preferences_dialog.label1);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label1), GTK_JUSTIFY_LEFT);

	preferences_dialog.fixed2 = gtk_fixed_new ();
	gtk_widget_show (preferences_dialog.fixed2);
	gtk_container_add (GTK_CONTAINER (preferences_dialog.notebook1), preferences_dialog.fixed2);

	preferences_dialog.label7 = gtk_label_new ("Highlighting Element");
	gtk_widget_show (preferences_dialog.label7);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed2), preferences_dialog.label7, 8, 16);
	gtk_widget_set_size_request (preferences_dialog.label7, 120, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label7), GTK_JUSTIFY_LEFT);

	preferences_dialog.combo1 = gtk_combo_new ();
	gtk_widget_show (preferences_dialog.combo1);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed2), preferences_dialog.combo1, 148, 14);
	gtk_widget_set_size_request (preferences_dialog.combo1, 179, 23);
	gtk_combo_set_use_arrows_always (GTK_COMBO (preferences_dialog.combo1), TRUE);
	preferences_dialog.combo1_items = NULL;
	preferences_dialog.combo1_items = g_list_append (preferences_dialog.combo1_items, (gpointer) "Default");
	preferences_dialog.combo1_items = g_list_append (preferences_dialog.combo1_items, (gpointer) "Keyword");
	preferences_dialog.combo1_items = g_list_append (preferences_dialog.combo1_items, (gpointer) "Comment");
	preferences_dialog.combo1_items = g_list_append (preferences_dialog.combo1_items, (gpointer) "Variable");
	gtk_combo_set_popdown_strings (GTK_COMBO (preferences_dialog.combo1), preferences_dialog.combo1_items);
	g_list_free (preferences_dialog.combo1_items);
	// TODO: Set up an on-change event on the combo to store the current values and load the new ones.

	preferences_dialog.combo_entry1 = GTK_COMBO (preferences_dialog.combo1)->entry;
	gtk_widget_show (preferences_dialog.combo_entry1);
	gtk_editable_set_editable (GTK_EDITABLE (preferences_dialog.combo_entry1), FALSE);

	preferences_dialog.fontpicker1 = gnome_font_picker_new ();
	gtk_widget_show (preferences_dialog.fontpicker1);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed2), preferences_dialog.fontpicker1, 56, 40);
	gtk_widget_set_size_request (preferences_dialog.fontpicker1, 32, 32);

	preferences_dialog.label8 = gtk_label_new ("Font");
	gtk_widget_show (preferences_dialog.label8);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed2), preferences_dialog.label8, 8, 48);
	gtk_widget_set_size_request (preferences_dialog.label8, 36, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label8), GTK_JUSTIFY_LEFT);

	preferences_dialog.label9 = gtk_label_new ("Foreground (text) colour");
	gtk_widget_show (preferences_dialog.label9);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed2), preferences_dialog.label9, 8, 88);
	gtk_widget_set_size_request (preferences_dialog.label9, 152, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label9), GTK_JUSTIFY_LEFT);

	preferences_dialog.label10 = gtk_label_new ("Background (paper) colour");
	gtk_widget_show (preferences_dialog.label10);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed2), preferences_dialog.label10, 16, 128);
	gtk_widget_set_size_request (preferences_dialog.label10, 160, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label10), GTK_JUSTIFY_LEFT);

	preferences_dialog.colorpicker2 = gnome_color_picker_new ();
	gtk_widget_show (preferences_dialog.colorpicker2);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed2), preferences_dialog.colorpicker2, 208, 80);
	gtk_widget_set_size_request (preferences_dialog.colorpicker2, 36, 28);

	preferences_dialog.colorpicker3 = gnome_color_picker_new ();
	gtk_widget_show (preferences_dialog.colorpicker3);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed2), preferences_dialog.colorpicker3, 208, 120);
	gtk_widget_set_size_request (preferences_dialog.colorpicker3, 36, 28);

	preferences_dialog.label2 = gtk_label_new ("Syntax Highlighting");
	gtk_widget_show (preferences_dialog.label2);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (preferences_dialog.notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (preferences_dialog.notebook1), 1), preferences_dialog.label2);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label2), GTK_JUSTIFY_LEFT);

	preferences_dialog.fixed3 = gtk_fixed_new ();
	gtk_widget_show (preferences_dialog.fixed3);
	gtk_container_add (GTK_CONTAINER (preferences_dialog.notebook1), preferences_dialog.fixed3);

	preferences_dialog.hscale4 = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (500, 0, 2500, 0, 0, 0)));
	gtk_widget_show (preferences_dialog.hscale4);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed3), preferences_dialog.hscale4, 176, 120);
	gtk_widget_set_size_request (preferences_dialog.hscale4, 152, 40);
	gtk_scale_set_digits (GTK_SCALE (preferences_dialog.hscale4), 0);

	preferences_dialog.hscale5 = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (500, 0, 2500, 0, 0, 0)));
	gtk_widget_show (preferences_dialog.hscale5);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed3), preferences_dialog.hscale5, 176, 64);
	gtk_widget_set_size_request (preferences_dialog.hscale5, 152, 40);
	gtk_scale_set_digits (GTK_SCALE (preferences_dialog.hscale5), 0);

	preferences_dialog.label12 = gtk_label_new ("Drop-down functions delay");
	gtk_widget_show (preferences_dialog.label12);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed3), preferences_dialog.label12, 8, 136);
	gtk_widget_set_size_request (preferences_dialog.label12, 160, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label12), GTK_JUSTIFY_LEFT);

	preferences_dialog.label11 = gtk_label_new ("Calltip (hint) function delay");
	gtk_widget_show (preferences_dialog.label11);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed3), preferences_dialog.label11, 8, 80);
	gtk_widget_set_size_request (preferences_dialog.label11, 160, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label11), GTK_JUSTIFY_LEFT);

	preferences_dialog.label13 = gtk_label_new ("PHP binary location");
	gtk_widget_show (preferences_dialog.label13);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed3), preferences_dialog.label13, 8, 24);
	gtk_widget_set_size_request (preferences_dialog.label13, 128, 16);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label13), GTK_JUSTIFY_LEFT);

	preferences_dialog.entry1 = gtk_entry_new ();
	gtk_widget_show (preferences_dialog.entry1);
	gtk_fixed_put (GTK_FIXED (preferences_dialog.fixed3), preferences_dialog.entry1, 136, 19);
	gtk_widget_set_size_request (preferences_dialog.entry1, 184, 27);

	preferences_dialog.label3 = gtk_label_new ("PHP Features");
	gtk_widget_show (preferences_dialog.label3);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (preferences_dialog.notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (preferences_dialog.notebook1), 2), preferences_dialog.label3);
	gtk_label_set_justify (GTK_LABEL (preferences_dialog.label3), GTK_JUSTIFY_LEFT);

	preferences_dialog.hbox1 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (preferences_dialog.hbox1);
	gtk_box_pack_start (GTK_BOX (preferences_dialog.vbox1), preferences_dialog.hbox1, FALSE, FALSE, 0);

	preferences_dialog.button1 = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (preferences_dialog.button1);
	gtk_box_pack_end (GTK_BOX (preferences_dialog.hbox1), preferences_dialog.button1, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (preferences_dialog.button1), 4);

	preferences_dialog.button2 = gtk_button_new_from_stock ("gtk-ok");
	gtk_widget_show (preferences_dialog.button2);
	gtk_box_pack_end (GTK_BOX (preferences_dialog.hbox1), preferences_dialog.button2, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (preferences_dialog.button2), 4);

	gtk_signal_connect (GTK_OBJECT (preferences_dialog.button2),
	                    "clicked", GTK_SIGNAL_FUNC (ok_clicked), NULL);

	// Hide the dialog box when the user clicks the cancel_button
	gtk_signal_connect_object (GTK_OBJECT (preferences_dialog.button1),
	                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), (gpointer) preferences_dialog.window);

	gtk_signal_connect(GTK_OBJECT(preferences_dialog.window), "destroy", GTK_SIGNAL_FUNC(preferences_window_destroyed), NULL);

	get_current_preferences();
}

